<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<con:xqueryEntry xmlns:con="http://www.bea.com/wli/sb/resources/config">
  <con:xquery>xquery version "1.0" encoding "Cp1252";
(:: pragma bea:global-element-parameter parameter="$req" element="ns0:GPS" location="../GenericParallelService.wsdl" ::)
(:: pragma  type="xs:anyType" ::)

declare namespace xf = "http://tempuri.org/GenericParallel/Impl/Validate/";
declare namespace ns0 = "http://genericparallel/types";
declare namespace soap-env = "http://schemas.xmlsoap.org/soap/envelope/";

declare function xf:Validate($req as element(ns0:GPS)) {
	let $gpsResult :=
		for $gpsAttr in $req/@*
		let $ln := local-name($gpsAttr)
		let $vl := data($gpsAttr)
		return
			if ( $ln = 'GPSMaxParallel' ) then (
				if( matches($vl,"^[1-9][0-9]*$") ) then ()
				else (
					&lt;soap-env:Fault&gt;
						&lt;faultcode&gt;GPS-0004&lt;/faultcode&gt;
						&lt;faultstring&gt;Invalid GPSMaxParallel:{$vl}&lt;/faultstring&gt;
						&lt;detail&gt;
							&lt;GPS&gt;
							Permitted values are positive integer, e.g. GPSMaxParallel="8"
							&lt;/GPS&gt;
						&lt;/detail&gt;
					&lt;/soap-env:Fault&gt;
				) 
			) 
			else if ( $ln = 'GPSFailMode' ) then (
				if( $vl = ("NEVER","ANY_REQUEST_FAILS","ALL_REQUESTS_FAIL") ) then ()
				else (
					&lt;soap-env:Fault&gt;
						&lt;faultcode&gt;GPS-0003&lt;/faultcode&gt;
						&lt;faultstring&gt;Invalid GPSFailMode:{$vl}&lt;/faultstring&gt;
						&lt;detail&gt;
							&lt;GPS&gt;
							Permitted values are NEVER,ANY_REQUEST_FAILS,ALL_REQUESTS_FAIL
							&lt;/GPS&gt;
						&lt;/detail&gt;
					&lt;/soap-env:Fault&gt;
				) 
			) 
			else if ( $ln = 'GPSDoNotSort' ) then (
				if( $vl = ("true","false") ) then ()
				else (
					&lt;soap-env:Fault&gt;
						&lt;faultcode&gt;GPS-0008&lt;/faultcode&gt;
						&lt;faultstring&gt;Invalid GPSDoNotSort:{$vl}&lt;/faultstring&gt;
						&lt;detail&gt;
							&lt;GPS&gt;
							Permitted values are true and false
							&lt;/GPS&gt;
						&lt;/detail&gt;
					&lt;/soap-env:Fault&gt;
				) 
			) 
			else (
				&lt;soap-env:Fault&gt;
					&lt;faultcode&gt;GPS-0002&lt;/faultcode&gt;
					&lt;faultstring&gt;Unknown GPS attribute:{$ln}&lt;/faultstring&gt;
					&lt;detail&gt;
						&lt;GPS&gt;
						Permitted attributes are: GPSMaxParallel, GPSFailMode
						&lt;/GPS&gt;
					&lt;/detail&gt;
				&lt;/soap-env:Fault&gt;
			)

	let $reqResult :=
		for $request in $req/ns0:Requests/ns0:Request
		return
			for $reqAttr in $request/@*
			let $ln := local-name($reqAttr)
			let $vl := data($reqAttr)
			return
			if ( $ln = 'GPSTargetIsProxy' ) then (
				if( $vl = ("false","true")  ) then ()
				else (
					&lt;soap-env:Fault&gt;
						&lt;faultcode&gt;GPS-0005&lt;/faultcode&gt;
						&lt;faultstring&gt;Invalid GPSTargetIsProxy:{$vl}&lt;/faultstring&gt;
						&lt;detail&gt;
							&lt;GPS&gt;
							Permitted values are true and false
							&lt;/GPS&gt;
						&lt;/detail&gt;
					&lt;/soap-env:Fault&gt;
				)
			) 
			else if ( $ln = 'GPSOperation' ) then (
			)
			else if ( $ln = 'GPSTarget' ) then (
				if( matches($vl,"^[^/].*[^/]$") ) then ()
				else (
					&lt;soap-env:Fault&gt;
						&lt;faultcode&gt;GPS-0009&lt;/faultcode&gt;
						&lt;faultstring&gt;Invalid GPSTarget:{$vl}&lt;/faultstring&gt;
						&lt;detail&gt;
							&lt;GPS&gt;
							Valid values are not starting with / and do not end with / or file extension, e.g. "Project/Folder/Service"
							&lt;/GPS&gt;
						&lt;/detail&gt;
					&lt;/soap-env:Fault&gt;
				) 
			) 
			else (
			)

	let $tgtResult :=
		for $request in $req/ns0:Requests/ns0:Request
		return 
			if( not($request/@GPSTarget) ) then (
				&lt;soap-env:Fault&gt;
					&lt;faultcode&gt;GPS-0007&lt;/faultcode&gt;
					&lt;faultstring&gt;Missing Request attribute GPSTarget&lt;/faultstring&gt;
					&lt;detail&gt;
						&lt;GPS&gt;
						Valid value is like GPSTarget="Project/Folder/Folder/Service"
						&lt;/GPS&gt;
					&lt;/detail&gt;
				&lt;/soap-env:Fault&gt;
			) else ()

			
	return
		if( $gpsResult ) then $gpsResult
		else if( $reqResult ) then $reqResult
		else if( $tgtResult ) then $tgtResult
		else ()
};

declare variable $req as element(ns0:GPS) external;

xf:Validate($req)
</con:xquery>
</con:xqueryEntry>
